#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
const ll MOD = 998244353;
const int N = 2e7+5;
const int M = 1e5+5;

int n,m;
ll a[N],b[M],c,bp[N];

int main()
{
    ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);
    cin>>n>>m;
    for(int i=1;i<=m;i++)cin>>b[i];
    cin>>c;
    for(int i=1;i<=n;i++)a[i]=i;

    for(int i=0;i<=n-m;i++){
        for(int j=1;j<=m;j++){
            a[i+b[j]]=a[i+j];
        }
    }
    ll bp=1,ans=0;
    for(int i=1;i<=n;i++){
        bp=c*bp%MOD;
        while(bp<0)bp+=MOD;
        ans+=a[i]*bp%MOD;
        if(ans>=MOD)ans%=MOD;
    }

    cout<<ans;

    return 0;
}